%Compute PHD: discrete Y case
%WYC 2015 (Biometrika) Model 4 (vary n-sigma)

clear
p=10;d=2;
ssize=200;

true1=[1,2,zeros(1,p-3),2]'/3;
true2=[0,0,3,4,zeros(1,p-4)]'/5;
B0=[true1,true2];
PB0=B0*(B0'*B0)^(-1)*B0';

[TCsir, TCPHD]=deal(zeros(ssize,2));
timePHD=zeros(ssize,1);

    for(i=1:ssize)
        i      % data-file index     
        filename=strcat('data_n200Sig2_',num2str(i),'.txt');
        data=dlmread(filename);
        x=data(:,1:p);
        y=data(:,p+1);  
        
        sir=invregDiscrete(x,y);
        format shortG %Specifying the format of the output in command window
        sirevals = round(sir.eigenvalue,5);  %Matches with "dr" package sir results 
        sirdir=sir.direction(:,1:d);
        sirPBest=sirdir*(sirdir'*sirdir)^(-1)*sirdir';
        TCsir(i,:) = [sqrt(trace(sirPBest*PB0)/d), max(abs(eig(PB0-sirPBest)))];    
        
        tic
        PHD=phd(x,y);
        timePHD(i)=toc;
        format shortG %Specifying the format of the output in command window
        %We have used the residual-based PHD for CIM paper
        PHDevals = round(PHD.reigenvalue,5);  
        PHDdir=PHD.rdirection(:,1:d);
        PHDPBest=PHDdir*(PHDdir'*PHDdir)^(-1)*PHDdir';
        TCPHD(i,:) = [sqrt(trace(PHDPBest*PB0)/d), max(abs(eig(PB0-PHDPBest)))];
    end
    
    [mean(TCsir(:,1)), mean(TCPHD(:,1)); std(TCsir(:,1)), std(TCPHD(:,1))]
    mean(timePHD)
    
    save PHDdiscrete_n200Sig2.mat
    
    