function[out]=SAVE(x,y,numslice)
%[out]=invreg(x,y,numrep) does the dimension reduction based on 
%sliced inverse regression. Each row of x and y represent an observation.
%numrep: the number of observations in each slice.


s=size(x);n=s(1);p=s(2);
if exist('numslice')==0
    numslice=10;   
end
[~,ind]=sort(y);
numrep=floor(n/numslice);
matx=0;ip=eye(p);
z=x*cov(x)^(-1/2);
for i=1:numslice-1
    matx=matx+numrep*(ip-cov(z(ind((i-1)*numrep+1:i*numrep),:)))^2;
end
matx=matx+(n-(numslice-1)*numrep)*(ip-cov(z(ind((numslice-1)*numrep+1:n),:)))^2;
matx=matx/n;
[sv,sd]=eig(matx); 
temp=diag(sd);[~,b]=sort(-temp);
sd=temp(b);
sv=cov(x)^(-1/2)*sv(:,b);
out.direction=sv;
out.eigenvalue=sd;
out.matx=matx;
out.numrep=numrep;