function[out]=invreg(x,y,numslice)
%[out]=invreg(x,y,numrep) does the dimension reduction based on 
%sliced inverse regression. Each row of x and y represent an observation.
%numrep: the number of observations in each slice.


n=length(y);
if exist('numslice')==0
    numslice=10;   
end
[sy,ind]=sort(y);mx=mean(x);
numrep=round(n/numslice);
matx=0;xbar=[];
for i=1:numslice-1
    xbar(i,:)=mean(x(ind((i-1)*numrep+1:i*numrep),:));
    matx=matx+numrep*(xbar(i,:)-mx)'*(xbar(i,:)-mx);
end
xbar(numslice,:)=mean(x(ind((numslice-1)*numrep+1:n),:));
matx=matx+(n-(numslice-1)*numrep)*(xbar(numslice,:)-mx)'*(xbar(numslice,:)-mx);
matx=(cov(x)*(n-1))^(-1)*matx;
[sv,sd]=eig(matx); 
temp=abs(diag(sd));[a,b]=sort(-temp);sd=temp(b);sv=sv(:,b);
out.direction=sv;
out.eigenvalue=sd;
out.matx=matx;
out.numrep=numrep;